import extConfig from "./lib/config.js";

import translateController from "./lib/translate.js";

translateController.baseUrl = extConfig.baseUrl, (() => {
    let e = [ {
        id: "openSettingPage",
        title: chrome.i18n.getMessage("open_setting_page"),
        type: "normal",
        contexts: [ "action" ],
        enabled: !0
    }, {
        id: "translateImageDom",
        title: chrome.i18n.getMessage("translate_image"),
        type: "normal",
        contexts: [ "image" ],
        enabled: !0
    }, {
        id: "translateSelectionText",
        title: chrome.i18n.getMessage("translate_to", [ "" ]) + " (%s)",
        type: "normal",
        contexts: [ "selection" ],
        enabled: !0
    }, {
        id: "extractWordForSelection",
        title: chrome.i18n.getMessage("extract_words_add_for_selection") + " (%s)",
        type: "normal",
        contexts: [ "selection" ],
        enabled: !0
    } ];
    async function l() {
        try {
            var e = new FormData();
            return e.append("requestSource", "plugin"), (await (await fetch(extConfig.baseUrl + "/User/get", {
                method: "POST",
                body: e
            })).json()).user || {};
        } catch (e) {
            return {};
        }
    }
    chrome.runtime.onInstalled.addListener(() => {
        extConfig.updateStorage(), e.forEach(e => {
            chrome.contextMenus?.create(e, () => {
                chrome.runtime.lastError && console.log("contextMenus create error: " + chrome.runtime.lastError.message);
            });
        });
    }), chrome.runtime.onStartup.addListener(() => {
        extConfig.syncTranslateServices(), extConfig.syncChatAIData();
    }), chrome.contextMenus?.onClicked.addListener((e, a) => {
        switch (e.menuItemId) {
          case "openSettingPage":
            let t = chrome.runtime.getURL("/options.html");
            chrome.tabs.query({
                url: t
            }).then(e => {
                e.length ? chrome.tabs.update(e[0].id, {
                    active: !0
                }) : chrome.tabs.create({
                    url: t
                });
            });
            break;

          case "translateImageDom":
            chrome.tabs.sendMessage(a.id, {
                action: "translateImageDom"
            });
            break;

          case "translateSelectionText":
            chrome.tabs.sendMessage(a.id, {
                action: "translateSelectionText",
                options: {
                    baseUrl: extConfig.baseUrl,
                    selectionText: e.selectionText
                }
            });
            break;

          case "extractWordForSelection":
            chrome.tabs.sendMessage(a.id, {
                action: "extractWordForSelection",
                options: {
                    selectionText: e.selectionText
                }
            });
        }
    }), chrome.runtime.onMessage.addListener((n, t, r) => {
        switch (n.action) {
          case "getBaseUrl":
            r(extConfig.baseUrl);
            break;

          case "getConfig":
            return extConfig.get(n.keys).then(e => r(e)), !0;

          case "setConfig":
            return extConfig.set(n.config).then(e => r(e)), !0;

          case "openSettingPage":
            let a = chrome.runtime.getURL("/options.html");
            chrome.tabs.query({
                url: a
            }).then(([ e ]) => {
                var t = a + ("" + (n.hash || ""));
                e && e.url === t ? (chrome.tabs.reload(e.id, {
                    bypassCache: !0
                }), chrome.tabs.update(e.id, {
                    active: !0
                })) : (e && chrome.tabs.remove(e.id), chrome.tabs.create({
                    url: t
                }));
            });
            break;

          case "updateContextMenus":
            e = n.data.id, s = n.data.updateProperties, chrome.contextMenus?.update(e, s);
            break;

          case "checkContentScriptInject":
            return chrome.tabs.query({
                active: !0,
                currentWindow: !0
            }).then(e => {
                chrome.tabs.sendMessage(e[0].id, {
                    action: "checkContentScriptInject"
                }).then(e => {
                    r(!0);
                }).catch(() => {
                    r(!1);
                });
            }), !0;

          case "getCurrentTab":
            return chrome.tabs.query({
                active: !0,
                currentWindow: !0
            }).then(e => r(e[0])), !0;

          case "getCurrentTabPageLangeuage":
            return chrome.tabs.query({
                active: !0,
                currentWindow: !0
            }).then(e => {
                e.length && chrome.tabs.sendMessage(e[0].id, {
                    action: "getPageLanguage"
                }).then(e => {
                    r(e);
                }).catch(() => {
                    r();
                });
            }), !0;

          case "getCurrentTabTranslateStatus":
            return chrome.tabs.query({
                active: !0,
                currentWindow: !0
            }).then(e => {
                e.length && chrome.tabs.sendMessage(e[0].id, {
                    action: "getTranslateStatus"
                }).then(e => {
                    r(e);
                }).catch(() => {
                    r({});
                });
            }), !0;

          case "getSubtitleInfo":
            return chrome.tabs.query({
                active: !0,
                currentWindow: !0
            }).then(e => {
                e.length && chrome.tabs.sendMessage(e[0].id, {
                    action: "getSubtitleInfo"
                }).then(e => {
                    r(e);
                }).catch(() => {
                    r({});
                });
            }), !0;

          case "translateImage":
            var {
                imgUrl: e,
                fromLangCode: s,
                toLangCode: o
            } = n.data;
            return h.translate(e, s, o).then(e => r(e)), !0;

          case "translateText":
            return chrome.storage.local.get("translateServices").then(({
                translateServices: e
            }) => {
                e = e.find(e => e.id === n.data.server);
                translateController.addTask(n.data.id || Math.random().toString(16), {
                    service: e,
                    textArr: n.data.textArr,
                    fromLangCode: n.data.options.from,
                    fromLangId: n.data.options.fromLangId,
                    toLangCode: n.data.options.to,
                    toLangId: n.data.options.toLangId,
                    translateUrl: t.url
                }).then(e => {
                    [ 50001, 50005 ].includes(e.code) && chrome.tabs.sendMessage(t.tab.id, {
                        action: "translateFail",
                        message: e.message
                    }).catch(() => {
                        chrome.runtime.lastError;
                    }), r(e);
                });
            }), !0;

          case "cancelTranslateTask":
            translateController.cancelTask(n.data.taskIds);
            break;

          case "toggleExtensionTranslateIcon":
            chrome.action.setIcon({
                path: n.translated ? "images/translated-y.png" : "images/translated-n.png",
                tabId: t.tab.id
            });
            break;

          case "toggleTranslatePage":
            chrome.tabs.query({
                active: !0,
                currentWindow: !0
            }).then(e => {
                e[0] && chrome.tabs.sendMessage(e[0].id, {
                    action: "toggleTranslatePage",
                    force: n.force
                });
            });
            break;

          case "toggleTranslatePageType":
            chrome.tabs.query({
                active: !0,
                currentWindow: !0
            }, e => {
                e[0] && chrome.tabs.sendMessage(e[0].id, {
                    action: "toggleTranslatePageType"
                });
            });
            break;

          case "setTranslateColorToTabs":
            extConfig.get([ "translateColorType", "customTranslateColor" ]).then(t => chrome.tabs.query({}).then(e => ({
                tabs: e,
                config: t
            }))).then(({
                tabs: e,
                config: t
            }) => {
                let a = {
                    action: "setTranslateColor",
                    translateColor: "custom" === t.translateColorType ? t.customTranslateColor : "inherit"
                };
                e.forEach(e => {
                    chrome.tabs.sendMessage(e.id, a, () => {
                        chrome.runtime.lastError;
                    });
                });
            });
            break;

          case "sendCode":
            return o = n.data, (g = new FormData()).append("email", o.email), g.append("requestSource", "plugin"), 
            fetch(extConfig.baseUrl + "/LoginAndOut/getEmailVerificationCode", {
                method: "POST",
                body: g
            }).then(function(e) {
                return e.json();
            }).then(function(e) {
                return e;
            }).then(e => r(e)), !0;

          case "getCaptcha":
            return (g = new FormData()).append("requestSource", "plugin"), fetch(extConfig.baseUrl + "/Captcha/generateBase64", {
                method: "POST",
                body: g
            }).then(function(e) {
                return e.text();
            }).then(function(e) {
                return e;
            }).catch(function(e) {}).then(e => r(e)), !0;

          case "login":
            return d = n.data, (u = new FormData()).append("email", d.email), u.append("verificationCode", d.code), 
            u.append("loginType", d.loginType), u.append("requestSource", "plugin"), 
            fetch(extConfig.baseUrl + "/LoginAndOut/onlyLoginByCode", {
                method: "POST",
                body: u
            }).then(function(e) {
                return e.json();
            }).then(function(e) {
                return e;
            }).catch(function(e) {
                return null;
            }).then(e => r(e)), !0;

          case "loginForPassword":
            return d = n.data, (u = new FormData()).append("email", d.email), u.append("password", d.password), 
            u.append("captcha", d.captcha), u.append("loginType", d.loginType), 
            u.append("requestSource", "plugin"), fetch(extConfig.baseUrl + "/LoginAndOut/loginByPassword", {
                method: "POST",
                body: u
            }).then(function(e) {
                return e.json();
            }).then(function(e) {
                return e;
            }).catch(function(e) {
                return null;
            }).then(e => r(e)), !0;

          case "logout":
            (i = new FormData()).append("requestSource", "plugin"), fetch(extConfig.baseUrl + "/LoginAndOut/logout", {
                method: "POST",
                body: i
            });

          case "saveLoginInfo":
            break;

          case "getLoginInfo":
            return l().then(e => r(e)), !0;

          case "textToMap3":
            return i = n.text, (c = new FormData()).append("text", i), c.append("requestSource", "plugin"), 
            fetch(extConfig.baseUrl + "/TextToSpeech/longTextToSpeechCreate", {
                method: "POST",
                body: c
            }).then(function(e) {
                return e.json();
            }).then(function(e) {
                return e;
            }).then(e => r(e)), !0;

          case "queryMap3":
            return function n(r) {
                return new Promise((t, a) => {
                    let e = new FormData();
                    e.append("requestSource", "plugin"), fetch(extConfig.baseUrl + "/TextToSpeech/longTextToSpeechQuery/" + r, {
                        method: "POST",
                        body: e
                    }).then(function(e) {
                        return e.json();
                    }).then(function(e) {
                        e.success || a(), e.speechUrl ? t(e) : setTimeout(() => {
                            n(r).then(t, a);
                        }, 3e3);
                    });
                });
            }(n.taskId).then(e => r(e)), !0;

          case "extractUrlWordsSentences":
            return (async e => {
                try {
                    var t = new FormData();
                    return t.append("url", e.url), t.append("toLanguageID", e.toLanguageID), 
                    t.append("requestSource", "plugin"), await (await fetch(extConfig.baseUrl + "/Ai/extractUrlWordsSentences", {
                        method: "POST",
                        body: t
                    })).json();
                } catch (e) {
                    return {
                        success: !1,
                        message: e.message
                    };
                }
            })(n.data).then(e => r(e)), !0;

          case "extractTextWordsSentences":
            return (async e => {
                try {
                    var t = new FormData();
                    return t.append("url", e.url), t.append("text", e.textContent), 
                    t.append("sourceLanguageID", e.sourceLanguageID), t.append("toLanguageID", e.toLanguageID), 
                    t.append("wordNum", e.extractWordNum), t.append("requestSource", "plugin"), 
                    await (await fetch(extConfig.baseUrl + "/Ai/extractTextWordsSentences", {
                        method: "POST",
                        body: t
                    })).json();
                } catch (e) {
                    return {
                        success: !1,
                        message: e.message
                    };
                }
            })(n.data).then(e => r(e)), !0;

          case "addWordForSelection":
            return (async e => {
                try {
                    var t = new FormData();
                    return t.append("url", e.url), t.append("word", e.word), t.append("explanation", e.explanation), 
                    t.append("requestSource", "plugin"), await (await fetch(extConfig.baseUrl + "/UserCollectionWords/addWord", {
                        method: "POST",
                        body: t
                    })).json();
                } catch (e) {
                    return {
                        success: !1,
                        message: e.message
                    };
                }
            })(n.data).then(e => r(e)), !0;

          case "userExtractUrlWords":
            return (async e => {
                try {
                    var t = new FormData(), a = (t.append("page", e.page), t.append("rows", e.rows), 
                    t.append("requestSource", "plugin"), e.searchDate ? "/" + e.searchDate : "");
                    return await (await fetch(extConfig.baseUrl + "/UserCollectionWords/data" + a, {
                        method: "POST",
                        body: t
                    })).json();
                } catch (e) {
                    return {
                        success: !1,
                        message: e.message
                    };
                }
            })(n.data).then(e => r(e)), !0;

          case "toggleExtractCollection":
            return (async e => {
                try {
                    var t = new FormData();
                    return t.append("userUrlExtractWordsSentencesLogID", e.id), 
                    t.append("requestSource", "plugin"), await (await fetch(extConfig.baseUrl + "/UserCollectionWords/changeCollection", {
                        method: "POST",
                        body: t
                    })).json();
                } catch (e) {
                    return {
                        success: !1,
                        message: e.message
                    };
                }
            })(n.data).then(e => r(e)), !0;

          case "deleteExtractWord":
            return (async e => {
                try {
                    var t = new FormData();
                    return t.append("id", e.id), t.append("requestSource", "plugin"), 
                    await (await fetch(extConfig.baseUrl + "/UserCollectionWords/deleteWord", {
                        method: "POST",
                        body: t
                    })).json();
                } catch (e) {
                    return {
                        success: !1,
                        message: e.message
                    };
                }
            })(n.data).then(e => r(e)), !0;

          case "extractTextGrammar":
            return (async e => {
                try {
                    var t = new FormData();
                    return t.append("url", e.url), t.append("text", e.text), t.append("sentenceNum", e.sentenceNum), 
                    t.append("sourceLanguageID", e.sourceLanguageID), t.append("toLanguageID", e.toLanguageID), 
                    t.append("requestSource", "plugin"), await (await fetch(extConfig.baseUrl + "/Ai/extractTextGrammar", {
                        method: "POST",
                        body: t
                    })).json();
                } catch (e) {
                    return {
                        success: !1,
                        message: e.message
                    };
                }
            })(n.data).then(e => r(e)), !0;

          case "getExtLanguageJSON":
            return (async e => {
                try {
                    var t = chrome.runtime.getURL(`/_locales/${e}/messages.json`);
                    return await (await fetch(t)).json();
                } catch (e) {
                    return {};
                }
            })(n.data.langCode).then(e => r(e)), !0;

          case "getTranslateServiceList":
            return l().then(async a => {
                var e = (await chrome.storage.local.get("translateServices")).translateServices;
                let t = e.reduce((e, t) => {
                    if (t.plusLevel) {
                        if (Number(t.plusLevel) < Number(a.plusLevel || 0) && !t.extensionSupport) return e;
                        Number(t.plusLevel) < Number(a.plusLevel || 0) && t.extensionSupport && (t.serverSupport = !1, 
                        t.config.provider = "CustomKey");
                    }
                    return e.push(t), e;
                }, []);
                t.find(e => e.default) || (t[0].default = !0, e.forEach(e => e.default = e.id === t[0].id)), 
                await chrome.storage.local.set({
                    translateServices: e
                }), t.forEach(e => {
                    let t = chrome.i18n.getMessage("translate_engine_" + e.id) || e.name;
                    e.config && (e.serverSupport && e.isPlus && e.extensionSupport ? t += " " + chrome.i18n.getMessage("translate_engine_plus_custom") : e.serverSupport && e.isPlus ? t += " " + chrome.i18n.getMessage("translate_engine_plus") : e.extensionSupport && (t += " " + chrome.i18n.getMessage("translate_engine_custom"))), 
                    e.nameWithTag = t;
                }), r(t);
            }), !0;
        }
        var c, i, d, u, g;
    }), chrome.runtime.onConnect.addListener(a => {
        "content-ai-chat" === a.name && (a.onMessage.addListener(e => {
            switch (e.type) {
              case "getChatInfo":
                t.init(e.data).then(({
                    chatInfo: e,
                    chatHistory: t
                }) => {
                    a.postMessage({
                        type: "getChatInfo__result",
                        success: !0,
                        chatInfo: e,
                        chatHistory: t
                    });
                }).catch(e => {
                    a.postMessage({
                        type: "getChatInfo__result",
                        success: !1,
                        message: e.message
                    });
                });
                break;

              case "sendPrologue":
                t.sendPrologue(e.data, e => {
                    a.postMessage({
                        type: "receiveMessage",
                        data: e
                    });
                });
                break;

              case "sendMessage":
                t.sendMessage(e.data, e => {
                    a.postMessage({
                        type: "receiveMessage",
                        data: e
                    });
                });
                break;

              case "getSuggestedQuestions":
                t.getSuggestedQuestions(e.data, e => {
                    a.postMessage({
                        type: "getSuggestedQuestions__result",
                        data: e
                    });
                });
            }
        }), a.onDisconnect.addListener(() => {
            console.log("content-ai-chat disconnected:", a.sender?.tab?.id);
        }));
    });
    let t = {
        init: function(s) {
            return new Promise(async (t, a) => {
                try {
                    let e = (await this.getChatInfo(s.url)).chatInfo;
                    e || (n = await this.createChatInfo(s), e = n.chatInfo), await this.checkAppStatus(e.id);
                    var n, r = await this.getChatHistory(e);
                    t({
                        chatInfo: e,
                        chatHistory: r
                    });
                } catch (e) {
                    a({
                        code: e.code || 500,
                        message: e.message || "Init failed"
                    });
                }
            });
        },
        getChatInfo: function(s) {
            return new Promise((t, a) => {
                var e = new FormData();
                e.append("url", s), e.append("requestSource", "plugin");
                let n = new AbortController(), r = setTimeout(() => n.abort(), 3e4);
                fetch(extConfig.baseUrl + "/UserDifyApps/getByURL", {
                    method: "POST",
                    body: e,
                    signal: n.signal
                }).then(e => e.json()).then(e => {
                    clearTimeout(r), t({
                        code: 200,
                        chatInfo: e && e.id ? e : null,
                        message: "Success"
                    });
                }).catch(e => {
                    clearTimeout(r), a({
                        code: 500,
                        chatInfo: null,
                        message: n.signal.aborted ? "请求超时" : e.message
                    });
                });
            });
        },
        createChatInfo: function(g) {
            return new Promise(async (t, a) => {
                try {
                    var n = g.fileName + ".html", r = new File([ g.fileContent ], n, {
                        type: "text/html"
                    }), s = new FormData();
                    s.append("file", r), s.append("requestSource", "plugin");
                    let e = new AbortController();
                    var o = setTimeout(() => e.abort(), 3e4), c = await fetch(extConfig.baseUrl + "/UserDifyApps/uploadHtmlFile", {
                        method: "POST",
                        body: s,
                        signal: e.signal
                    }), i = (clearTimeout(o), await c.json());
                    if (!i.success) throw new Error("上传文件失败");
                    var d = new FormData();
                    d.append("fileType", 2), d.append("fileID", i.fileID), d.append("url", g.url), 
                    d.append("dataDifyAiID", g.difyAiID), d.append("requestSource", "plugin");
                    var u = await (await fetch(extConfig.baseUrl + "/UserDifyApps/add", {
                        method: "POST",
                        body: d
                    })).json();
                    if (!u.success) throw new Error(u.message || "应用创建失败");
                    t({
                        code: 200,
                        chatInfo: u.userDifyApp,
                        message: "Success"
                    });
                } catch (e) {
                    a({
                        code: e.code || 500,
                        chatInfo: null,
                        message: e.message.includes("aborted") ? "请求超时" : e.message
                    });
                }
            });
        },
        checkAppStatus: function(n, r = 500) {
            return new Promise(async (t, a) => {
                await new Promise(e => setTimeout(e, r));
                var e = new FormData();
                e.append("requestSource", "plugin"), fetch(extConfig.baseUrl + "/UserDifyApps/getDocumentIndexingStatus/" + n, {
                    method: "POST",
                    body: e
                }).then(e => e.json()).then(e => {
                    e.success ? "completed" === e.indexingStatus ? t(e) : this.checkAppStatus(n, 2e3).then(t).catch(a) : a({
                        code: 500,
                        message: res.message
                    });
                }).catch(e => {
                    a({
                        code: 500,
                        message: e.message
                    });
                });
            });
        },
        getChatHistory: function(n) {
            return new Promise(async (t, e) => {
                var a = new FormData();
                a.append("userDifyAppID", n.id), a.append("limit", 500), a.append("requestSource", "plugin"), 
                fetch(extConfig.baseUrl + "/UserDifyApps/getConversationHistory", {
                    method: "POST",
                    body: a
                }).then(e => e.json()).then(e => {
                    e.success ? t(e.data.data) : t([]);
                }).catch(e => {
                    t([]);
                });
            });
        },
        sendPrologue: function(e, t) {
            var a = new FormData();
            a.append("userDifyAppID", e.chatId), a.append("requestSource", "plugin"), 
            fetch(extConfig.baseUrl + "/UserDifyApps/sendMessageStream", {
                method: "POST",
                body: a
            }).then(e => {
                this.processMessage(e, t);
            });
        },
        sendMessage: function(e, t) {
            var a = new FormData();
            a.append("userDifyAppID", e.chatId), a.append("query", e.message), a.append("requestSource", "plugin"), 
            fetch(extConfig.baseUrl + "/UserDifyApps/sendMessageStream", {
                method: "POST",
                body: a
            }).then(e => {
                this.processMessage(e, t);
            });
        },
        processMessage: function(e, a) {
            let r = e.body.getReader(), s = "", n = [], o = !1, c = null, i = "", d = "", u = ((async () => {
                for (;;) {
                    var {
                        done: e,
                        value: t
                    } = await r.read();
                    if (e) {
                        l();
                        break;
                    }
                    for (s += new TextDecoder("utf-8").decode(t); 0 <= (n = s.indexOf("\n\n")); ) {
                        var a = s.substring(0, n), n = (s = s.substring(n + 2), 
                        a.split("\n").filter(e => e.startsWith("data:")).map(e => e.slice(5).trim()).join("\n"));
                        n && u(n.trimEnd());
                    }
                }
            })(), e => {
                try {
                    var t = JSON.parse(e);
                    "message" === t.event && (d = t.message_id, n.push(...t.answer.split("")), 
                    o || g());
                } catch (e) {
                    console.error("JSON 解析失败:", e);
                }
            }), g = () => {
                o = !0;
                let t = () => {
                    var e;
                    0 === n.length ? o = !1 : (e = n.splice(0, 10).join(""), i += e, 
                    a({
                        content: i,
                        messageId: d
                    }), c = setTimeout(t, 50));
                };
                t();
            }, l = () => {
                0 < n.length && (i += n.join(""), a({
                    content: i,
                    messageId: d
                }), n = []), c && clearTimeout(c), o = !1, a({
                    done: !0,
                    messageId: d
                });
            };
        },
        getSuggestedQuestions: function(e, t) {
            var a = new FormData();
            a.append("requestSource", "plugin"), fetch(`${extConfig.baseUrl}/UserDifyApps/getSuggestedQuestions/${e.chatId}/` + e.messageId, {
                method: "POST",
                body: a
            }).then(e => e.json()).then(e => {
                e.success ? t(e.data.data) : t([]);
            }).catch(e => {
                t([]);
            });
        }
    }, h = {
        supportedTargetLang: [ {
            code: "zh",
            name: "中文",
            extCode: "zh-CN"
        }, {
            code: "zh",
            name: "中文",
            extCode: "zh-TW"
        }, {
            code: "en",
            name: "英语",
            extCode: "en"
        }, {
            code: "jp",
            name: "日语",
            extCode: "ja"
        }, {
            code: "kor",
            name: "韩语",
            extCode: "ko"
        }, {
            code: "fra",
            name: "法语",
            extCode: "fr"
        }, {
            code: "spa",
            name: "西班牙语",
            extCode: "es"
        }, {
            code: "ru",
            name: "俄语",
            extCode: "ru"
        }, {
            code: "pt",
            name: "葡萄牙语",
            extCode: "pt"
        }, {
            code: "de",
            name: "德语",
            extCode: "de"
        }, {
            code: "it",
            name: "意大利语",
            extCode: "it"
        }, {
            code: "dan",
            name: "丹麦语",
            extCode: "da"
        }, {
            code: "nl",
            name: "荷兰语",
            extCode: "nl"
        }, {
            code: "may",
            name: "马来语",
            extCode: "ms"
        }, {
            code: "swe",
            name: "瑞典语",
            extCode: "sv"
        }, {
            code: "id",
            name: "印尼语",
            extCode: "id"
        }, {
            code: "pl",
            name: "波兰语",
            extCode: "pl"
        }, {
            code: "rom",
            name: "罗马尼亚语",
            extCode: "ro"
        }, {
            code: "tr",
            name: "土耳其语",
            extCode: "tr"
        }, {
            code: "el",
            name: "希腊语",
            extCode: "el"
        }, {
            code: "hu",
            name: "匈牙利语",
            extCode: "hu"
        } ],
        cacheList: [],
        translate: async function(e, a, n) {
            try {
                if (!e) throw new Error("Image data is required");
                if (a = a || "auto", !n) throw new Error("Target is required");
                var r = await (await fetch(e)).blob(), s = await createImageBitmap(r), {
                    width: o,
                    height: c
                } = s, {
                    canvasWidth: i,
                    canvasHeight: d,
                    drawRegion: u
                } = this.calculateCanvasDimensions(o, c), g = new OffscreenCanvas(i, d), l = g.getContext("2d"), h = (l.fillStyle = "white", 
                l.fillRect(0, 0, i, d), l.drawImage(s, u.x, u.y, u.width, u.height), 
                await this.canvasToBase64(g));
                let t = `[${a}-->${n}] ` + h;
                var p = this.cacheList.find(e => e.key === t);
                if (p) return {
                    success: !0,
                    transBase64: p.transBase64,
                    message: "Image translation succeeded"
                };
                var m = new FormData();
                m.append("fromLanguageCode", this.formatLanguageCode(a)), m.append("toLanguageCode", this.formatLanguageCode(n)), 
                m.append("imgFile", h), m.append("requestSource", "plugin");
                var f, b = await (await fetch(extConfig.baseUrl + "/Translation/imgTrans", {
                    method: "POST",
                    body: m,
                    timeout: 3e4
                })).json();
                if (b.success) return f = await this.processTranslatedImage(b.resultImg, i, d, u), 
                this.cacheList.push({
                    key: t,
                    base64: h,
                    transBase64: f
                }), {
                    success: !0,
                    transBase64: f,
                    message: "Image translation succeeded"
                };
                {
                    let e = "";
                    return {
                        success: !1,
                        transBase64: null,
                        message: e = 50001 === Number(b.errorCode) ? chrome.i18n.getMessage("login_no") : b.message,
                        errorCode: Number(b.errorCode || 500),
                        supportedTargetLang: this.supportedTargetLang
                    };
                }
            } catch (e) {
                return {
                    success: !1,
                    transBase64: null,
                    message: e.message,
                    errorCode: 500
                };
            }
        },
        calculateCanvasDimensions: function(e, t) {
            var a = Math.min(e, t), n = Math.max(e, t);
            let r, s, o, c;
            c = 30 <= a && n <= 4096 && n / a <= 3 ? (r = e, s = t, o = e, t) : (n = this.adjustDimensions(e, t), 
            r = n.canvasWidth, s = n.canvasHeight, o = n.drawWidth, n.drawHeight);
            a = (r - o) / 2, e = (s - c) / 2;
            return {
                canvasWidth: r,
                canvasHeight: s,
                drawRegion: {
                    x: a,
                    y: e,
                    width: o,
                    height: c
                }
            };
        },
        adjustDimensions: function(e, t) {
            var a = e / t;
            let n = a < 1 / 3 ? 1 / 3 : 3 < a ? 3 : a, r, s;
            1 <= n ? (r = Math.min(4096, e), (s = r / n) < 30 && (s = 30, r = s * n)) : (s = Math.min(4096, t), 
            (r = s * n) < 30 && (r = 30, s = r / n));
            a = e / t;
            let o, c;
            return a > n ? (o = r, c = o / a) : (c = s, o = c * a), {
                canvasWidth: Math.round(r),
                canvasHeight: Math.round(s),
                drawWidth: Math.round(o),
                drawHeight: Math.round(c)
            };
        },
        processTranslatedImage: async function(e, t, a, n) {
            var e = this.dataURLToBlob(e), e = await createImageBitmap(e), r = new OffscreenCanvas(t, a), s = r.getContext("2d"), s = (s.fillStyle = "white", 
            s.fillRect(0, 0, t, a), s.drawImage(e, 0, 0, t, a), new OffscreenCanvas(n.width, n.height));
            return s.getContext("2d").drawImage(r, n.x, n.y, n.width, n.height, 0, 0, n.width, n.height), 
            this.canvasToBase64(s);
        },
        canvasToBase64: async function(e) {
            let a = await e.convertToBlob({
                type: "image/png"
            });
            return new Promise(e => {
                let t = new FileReader();
                t.onloadend = () => e(t.result), t.readAsDataURL(a);
            });
        },
        dataURLToBlob: function(e) {
            var e = e.split(","), t = e[0].match(/:(.*?);/)[1], a = atob(e[1]), n = new Uint8Array(a.length);
            for (let e = 0; e < a.length; e++) n[e] = a.charCodeAt(e);
            return new Blob([ n ], {
                type: t
            });
        },
        formatLanguageCode: function(t) {
            var e = this.supportedTargetLang.find(e => e.extCode === t);
            return e ? e.code : t;
        }
    };
})();