let lang = {
    allLanguageNames: {
        "zh-CN": {
            "zh-CN": {
                DeepLLangCode: "ZH-HANS",
                id: "59",
                name: "中文（简体）"
            },
            "zh-TW": {
                DeepLLangCode: "ZH-HANT",
                id: "63",
                name: "中文（繁体）"
            },
            en: {
                DeepLLangCode: "en",
                id: "70",
                name: "英文"
            },
            sq: {
                DeepLLangCode: "",
                id: "1",
                name: "阿尔巴尼亚语"
            },
            ar: {
                DeepLLangCode: "ar",
                id: "35",
                name: "阿拉伯语"
            },
            az: {
                DeepLLangCode: "",
                id: "37",
                name: "阿塞拜疆语"
            },
            ga: {
                DeepLLangCode: "",
                id: "18",
                name: "爱尔兰语"
            },
            et: {
                DeepLLangCode: "et",
                id: "9",
                name: "爱沙尼亚语"
            },
            bg: {
                DeepLLangCode: "bg",
                id: "3",
                name: "保加利亚语"
            },
            is: {
                DeepLLangCode: "",
                id: "17",
                name: "冰岛语"
            },
            pl: {
                DeepLLangCode: "pl",
                id: "26",
                name: "波兰语"
            },
            fa: {
                DeepLLangCode: "",
                id: "56",
                name: "波斯语"
            },
            da: {
                DeepLLangCode: "da",
                id: "7",
                name: "丹麦语"
            },
            de: {
                DeepLLangCode: "de",
                id: "12",
                name: "德语"
            },
            ru: {
                DeepLLangCode: "ru",
                id: "58",
                name: "俄语"
            },
            fr: {
                DeepLLangCode: "fr",
                id: "10",
                name: "法语"
            },
            fi: {
                DeepLLangCode: "fi",
                id: "11",
                name: "芬兰语"
            },
            ka: {
                DeepLLangCode: "",
                id: "13",
                name: "格鲁吉亚语"
            },
            gu: {
                DeepLLangCode: "",
                id: "41",
                name: "古吉拉特语"
            },
            ht: {
                DeepLLangCode: "",
                id: "71",
                name: "海地克里奥尔语"
            },
            ko: {
                DeepLLangCode: "ko",
                id: "46",
                name: "韩语"
            },
            nl: {
                DeepLLangCode: "nl",
                id: "8",
                name: "荷兰语"
            },
            ca: {
                DeepLLangCode: "",
                id: "4",
                name: "加泰罗尼亚语"
            },
            cs: {
                DeepLLangCode: "cs",
                id: "6",
                name: "捷克语"
            },
            kn: {
                DeepLLangCode: "",
                id: "49",
                name: "卡纳达语"
            },
            hr: {
                DeepLLangCode: "",
                id: "5",
                name: "克罗地亚语"
            },
            lv: {
                DeepLLangCode: "lv",
                id: "20",
                name: "拉脱维亚语"
            },
            lo: {
                DeepLLangCode: "",
                id: "50",
                name: "老挝语"
            },
            lt: {
                DeepLLangCode: "lt",
                id: "21",
                name: "立陶宛语"
            },
            ro: {
                DeepLLangCode: "ro",
                id: "27",
                name: "罗马尼亚语"
            },
            mt: {
                DeepLLangCode: "",
                id: "23",
                name: "马耳他语"
            },
            mr: {
                DeepLLangCode: "",
                id: "53",
                name: "马拉地语"
            },
            ml: {
                DeepLLangCode: "",
                id: "54",
                name: "马拉雅拉姆语"
            },
            ms: {
                DeepLLangCode: "",
                id: "51",
                name: "马来语"
            },
            mk: {
                DeepLLangCode: "",
                id: "22",
                name: "马其顿语"
            },
            bn: {
                DeepLLangCode: "",
                id: "38",
                name: "孟加拉语"
            },
            my: {
                DeepLLangCode: "",
                id: "39",
                name: "缅甸语"
            },
            no: {
                DeepLLangCode: "",
                id: "24",
                name: "挪威语"
            },
            pa: {
                DeepLLangCode: "",
                id: "57",
                name: "旁遮普语"
            },
            pt: {
                DeepLLangCode: "pt",
                id: "25",
                name: "葡萄牙语"
            },
            ja: {
                DeepLLangCode: "ja",
                id: "45",
                name: "日语"
            },
            sv: {
                DeepLLangCode: "sv",
                id: "28",
                name: "瑞典语"
            },
            sr: {
                DeepLLangCode: "",
                id: "30",
                name: "塞尔维亚语"
            },
            si: {
                DeepLLangCode: "",
                id: "60",
                name: "僧伽罗语"
            },
            sk: {
                DeepLLangCode: "sk",
                id: "31",
                name: "斯洛伐克语"
            },
            sl: {
                DeepLLangCode: "sl",
                id: "32",
                name: "斯洛文尼亚语"
            },
            sw: {
                DeepLLangCode: "",
                id: "74",
                name: "斯瓦希里语"
            },
            te: {
                DeepLLangCode: "",
                id: "66",
                name: "泰卢固语"
            },
            ta: {
                DeepLLangCode: "",
                id: "65",
                name: "泰米尔语"
            },
            th: {
                DeepLLangCode: "",
                id: "64",
                name: "泰语"
            },
            tr: {
                DeepLLangCode: "tr",
                id: "33",
                name: "土耳其语"
            },
            uk: {
                DeepLLangCode: "uk",
                id: "34",
                name: "乌克兰语"
            },
            es: {
                DeepLLangCode: "es",
                id: "73",
                name: "西班牙语"
            },
            he: {
                DeepLLangCode: "",
                id: "42",
                name: "希伯来语"
            },
            el: {
                DeepLLangCode: "el",
                id: "14",
                name: "希腊语"
            },
            hu: {
                DeepLLangCode: "hu",
                id: "15",
                name: "匈牙利语"
            },
            hy: {
                DeepLLangCode: "",
                id: "36",
                name: "亚美尼亚语"
            },
            it: {
                DeepLLangCode: "it",
                id: "16",
                name: "意大利语"
            },
            hi: {
                DeepLLangCode: "",
                id: "43",
                name: "印地语"
            },
            id: {
                DeepLLangCode: "id",
                id: "44",
                name: "印尼语"
            },
            vi: {
                DeepLLangCode: "",
                id: "68",
                name: "越南语"
            }
        },
        en: {
            "zh-CN": {
                DeepLLangCode: "ZH-HANS",
                id: "59",
                name: "Chinese (Simplified)"
            },
            "zh-TW": {
                DeepLLangCode: "ZH-HANT",
                id: "63",
                name: "Chinese (Traditional)"
            },
            en: {
                DeepLLangCode: "en",
                id: "70",
                name: "English"
            },
            sq: {
                DeepLLangCode: "",
                id: "1",
                name: "Albanian"
            },
            ar: {
                DeepLLangCode: "ar",
                id: "35",
                name: "Arabic"
            },
            az: {
                DeepLLangCode: "",
                id: "37",
                name: "Azerbaijani"
            },
            ga: {
                DeepLLangCode: "",
                id: "18",
                name: "Irish"
            },
            et: {
                DeepLLangCode: "et",
                id: "9",
                name: "Estonian"
            },
            bg: {
                DeepLLangCode: "bg",
                id: "3",
                name: "Bulgarian"
            },
            is: {
                DeepLLangCode: "",
                id: "17",
                name: "Icelandic"
            },
            pl: {
                DeepLLangCode: "pl",
                id: "26",
                name: "Polish"
            },
            fa: {
                DeepLLangCode: "",
                id: "56",
                name: "Persian"
            },
            da: {
                DeepLLangCode: "da",
                id: "7",
                name: "Danish"
            },
            de: {
                DeepLLangCode: "de",
                id: "12",
                name: "German"
            },
            ru: {
                DeepLLangCode: "ru",
                id: "58",
                name: "Russian"
            },
            fr: {
                DeepLLangCode: "fr",
                id: "10",
                name: "French"
            },
            ka: {
                DeepLLangCode: "",
                id: "13",
                name: "Georgian"
            },
            gu: {
                DeepLLangCode: "",
                id: "41",
                name: "Gujarati"
            },
            ht: {
                DeepLLangCode: "",
                id: "71",
                name: "Haitian Creole"
            },
            ko: {
                DeepLLangCode: "ko",
                id: "46",
                name: "Korean"
            },
            nl: {
                DeepLLangCode: "nl",
                id: "8",
                name: "Dutch"
            },
            ca: {
                DeepLLangCode: "",
                id: "4",
                name: "Catalan"
            },
            cs: {
                DeepLLangCode: "cs",
                id: "6",
                name: "Czech"
            },
            kn: {
                DeepLLangCode: "",
                id: "49",
                name: "Kannada"
            },
            hr: {
                DeepLLangCode: "",
                id: "5",
                name: "Croatian"
            },
            lv: {
                DeepLLangCode: "lv",
                id: "20",
                name: "Latvian"
            },
            lo: {
                DeepLLangCode: "",
                id: "50",
                name: "Lao"
            },
            lt: {
                DeepLLangCode: "lt",
                id: "21",
                name: "Lithuanian"
            },
            ro: {
                DeepLLangCode: "ro",
                id: "27",
                name: "Romanian"
            },
            mt: {
                DeepLLangCode: "",
                id: "23",
                name: "Maltese"
            },
            mr: {
                DeepLLangCode: "",
                id: "53",
                name: "Malay"
            },
            ml: {
                DeepLLangCode: "",
                id: "54",
                name: "Malayalam"
            },
            ms: {
                DeepLLangCode: "",
                id: "51",
                name: "Malay"
            },
            mk: {
                DeepLLangCode: "",
                id: "22",
                name: "Macedonian"
            },
            bn: {
                DeepLLangCode: "",
                id: "38",
                name: "Bengali"
            },
            my: {
                DeepLLangCode: "",
                id: "39",
                name: "Burmese"
            },
            no: {
                DeepLLangCode: "",
                id: "24",
                name: "Norwegian"
            },
            pa: {
                DeepLLangCode: "",
                id: "57",
                name: "Punjabi"
            },
            pt: {
                DeepLLangCode: "pt",
                id: "25",
                name: "Portuguese"
            },
            ja: {
                DeepLLangCode: "ja",
                id: "45",
                name: "Japanese"
            },
            sv: {
                DeepLLangCode: "sv",
                id: "28",
                name: "Swedish"
            },
            sr: {
                DeepLLangCode: "",
                id: "30",
                name: "Serbian"
            },
            si: {
                DeepLLangCode: "",
                id: "60",
                name: "Sinhalese"
            },
            sk: {
                DeepLLangCode: "sk",
                id: "31",
                name: "Slovak"
            },
            sl: {
                DeepLLangCode: "sl",
                id: "32",
                name: "Slovenian"
            },
            sw: {
                DeepLLangCode: "",
                id: "74",
                name: "Swahili"
            },
            te: {
                DeepLLangCode: "",
                id: "66",
                name: "Telugu"
            },
            ta: {
                DeepLLangCode: "",
                id: "65",
                name: "Tamil"
            },
            th: {
                DeepLLangCode: "",
                id: "64",
                name: "Thai"
            },
            tr: {
                DeepLLangCode: "tr",
                id: "33",
                name: "Turkish"
            },
            uk: {
                DeepLLangCode: "uk",
                id: "34",
                name: "Ukrainian"
            },
            es: {
                DeepLLangCode: "es",
                id: "73",
                name: "Spanish"
            },
            he: {
                DeepLLangCode: "",
                id: "42",
                name: "Hebrew"
            },
            el: {
                DeepLLangCode: "el",
                id: "14",
                name: "Greek"
            },
            hu: {
                DeepLLangCode: "hu",
                id: "15",
                name: "Hungarian"
            },
            hy: {
                DeepLLangCode: "",
                id: "36",
                name: "Armenian"
            },
            it: {
                DeepLLangCode: "it",
                id: "16",
                name: "Italian"
            },
            hi: {
                DeepLLangCode: "",
                id: "43",
                name: "Hindi"
            },
            id: {
                DeepLLangCode: "id",
                id: "44",
                name: "Indonesian"
            },
            vi: {
                DeepLLangCode: "",
                id: "68",
                name: "Vietnamese "
            }
        },
        id: {
            "zh-CN": {
                DeepLLangCode: "ZH-HANS",
                id: "59",
                name: "Cina (Sederhana)"
            },
            "zh-TW": {
                DeepLLangCode: "ZH-HANT",
                id: "63",
                name: "Cina (Tradisional)"
            },
            en: {
                DeepLLangCode: "en",
                id: "70",
                name: "Bahasa inggris"
            },
            sq: {
                DeepLLangCode: "",
                id: "1",
                name: "bahasa Albania"
            },
            ar: {
                DeepLLangCode: "ar",
                id: "35",
                name: "Arab"
            },
            az: {
                DeepLLangCode: "",
                id: "37",
                name: "Azerbaijan"
            },
            ga: {
                DeepLLangCode: "",
                id: "18",
                name: "Irlandia"
            },
            et: {
                DeepLLangCode: "et",
                id: "9",
                name: "Estonia"
            },
            bg: {
                DeepLLangCode: "bg",
                id: "3",
                name: "Bulgaria"
            },
            is: {
                DeepLLangCode: "",
                id: "17",
                name: "Islandia"
            },
            pl: {
                DeepLLangCode: "pl",
                id: "26",
                name: "Polandia"
            },
            fa: {
                DeepLLangCode: "",
                id: "56",
                name: "Persia"
            },
            da: {
                DeepLLangCode: "da",
                id: "7",
                name: "Denmark"
            },
            de: {
                DeepLLangCode: "de",
                id: "12",
                name: "Jerman"
            },
            ru: {
                DeepLLangCode: "ru",
                id: "58",
                name: "Rusia"
            },
            fr: {
                DeepLLangCode: "fr",
                id: "10",
                name: "Perancis"
            },
            fi: {
                DeepLLangCode: "fi",
                id: "11",
                name: "Finlandia"
            },
            ka: {
                DeepLLangCode: "",
                id: "13",
                name: "orang Georgia"
            },
            gu: {
                DeepLLangCode: "",
                id: "41",
                name: "gujarati"
            },
            ht: {
                DeepLLangCode: "",
                id: "71",
                name: "Kreol Haiti"
            },
            ko: {
                DeepLLangCode: "ko",
                id: "46",
                name: "Korea"
            },
            nl: {
                DeepLLangCode: "nl",
                id: "8",
                name: "Belanda"
            },
            ca: {
                DeepLLangCode: "",
                id: "4",
                name: "Katalan"
            },
            cs: {
                DeepLLangCode: "cs",
                id: "6",
                name: "Ceko"
            },
            kn: {
                DeepLLangCode: "",
                id: "49",
                name: "kannada"
            },
            hr: {
                DeepLLangCode: "",
                id: "5",
                name: "Kroasia"
            },
            lv: {
                DeepLLangCode: "lv",
                id: "20",
                name: "Latvia"
            },
            lo: {
                DeepLLangCode: "",
                id: "50",
                name: "Laos"
            },
            lt: {
                DeepLLangCode: "lt",
                id: "21",
                name: "Lithuania"
            },
            ro: {
                DeepLLangCode: "ro",
                id: "27",
                name: "Rumania"
            },
            mt: {
                DeepLLangCode: "",
                id: "23",
                name: "Malta"
            },
            mr: {
                DeepLLangCode: "",
                id: "53",
                name: "marathi"
            },
            ml: {
                DeepLLangCode: "",
                id: "54",
                name: "Malayalam"
            },
            ms: {
                DeepLLangCode: "",
                id: "51",
                name: "Melayu"
            },
            mk: {
                DeepLLangCode: "",
                id: "22",
                name: "Makedonia"
            },
            bn: {
                DeepLLangCode: "",
                id: "38",
                name: "Benggala"
            },
            my: {
                DeepLLangCode: "",
                id: "39",
                name: "Birma"
            },
            no: {
                DeepLLangCode: "",
                id: "24",
                name: "Norwegia"
            },
            pa: {
                DeepLLangCode: "",
                id: "57",
                name: "punjabi"
            },
            pt: {
                DeepLLangCode: "pt",
                id: "25",
                name: "Portugis"
            },
            ja: {
                DeepLLangCode: "ja",
                id: "45",
                name: "Jepang"
            },
            sv: {
                DeepLLangCode: "sv",
                id: "28",
                name: "Swedia"
            },
            sr: {
                DeepLLangCode: "",
                id: "30",
                name: "Serbia"
            },
            si: {
                DeepLLangCode: "",
                id: "60",
                name: "sinhala"
            },
            sk: {
                DeepLLangCode: "sk",
                id: "31",
                name: "bahasa Slowakia"
            },
            sl: {
                DeepLLangCode: "sl",
                id: "32",
                name: "bahasa Slovenia"
            },
            sw: {
                DeepLLangCode: "",
                id: "74",
                name: "Swahili"
            },
            te: {
                DeepLLangCode: "",
                id: "66",
                name: "bahasa Telugu"
            },
            ta: {
                DeepLLangCode: "",
                id: "65",
                name: "Tamil"
            },
            th: {
                DeepLLangCode: "",
                id: "64",
                name: "Thai"
            },
            tr: {
                DeepLLangCode: "tr",
                id: "33",
                name: "Turki"
            },
            uk: {
                DeepLLangCode: "uk",
                id: "34",
                name: "Ukraina"
            },
            es: {
                DeepLLangCode: "es",
                id: "73",
                name: "Spanyol"
            },
            he: {
                DeepLLangCode: "",
                id: "42",
                name: "Ibrani"
            },
            el: {
                DeepLLangCode: "el",
                id: "14",
                name: "Orang yunani"
            },
            hu: {
                DeepLLangCode: "hu",
                id: "15",
                name: "Hongaria"
            },
            hy: {
                DeepLLangCode: "",
                id: "36",
                name: "orang Armenia"
            },
            it: {
                DeepLLangCode: "it",
                id: "16",
                name: "Italia"
            },
            hi: {
                DeepLLangCode: "",
                id: "43",
                name: "Hindi"
            },
            id: {
                DeepLLangCode: "id",
                id: "44",
                name: "Indonesia"
            },
            vi: {
                DeepLLangCode: "",
                id: "68",
                name: "Vietnam"
            }
        },
        ja: {
            "zh-CN": {
                DeepLLangCode: "ZH-HANS",
                id: "59",
                name: "中国語(簡体字)"
            },
            "zh-TW": {
                DeepLLangCode: "ZH-HANT",
                id: "63",
                name: "中国語（繁体字）"
            },
            en: {
                DeepLLangCode: "en",
                id: "70",
                name: "英語"
            },
            sq: {
                DeepLLangCode: "",
                id: "1",
                name: "アルバニア語"
            },
            ar: {
                DeepLLangCode: "ar",
                id: "35",
                name: "アラビア語"
            },
            az: {
                DeepLLangCode: "",
                id: "37",
                name: "アゼルバイジャン語"
            },
            ga: {
                DeepLLangCode: "",
                id: "18",
                name: "アイルランド語"
            },
            et: {
                DeepLLangCode: "et",
                id: "9",
                name: "エストニア語"
            },
            bg: {
                DeepLLangCode: "bg",
                id: "3",
                name: "ブルガリア語"
            },
            is: {
                DeepLLangCode: "",
                id: "17",
                name: "アイスランド語"
            },
            pl: {
                DeepLLangCode: "pl",
                id: "26",
                name: "ポーランド語"
            },
            fa: {
                DeepLLangCode: "",
                id: "56",
                name: "ペルシャ語"
            },
            da: {
                DeepLLangCode: "da",
                id: "7",
                name: "デンマーク語"
            },
            de: {
                DeepLLangCode: "de",
                id: "12",
                name: "ドイツ語"
            },
            ru: {
                DeepLLangCode: "ru",
                id: "58",
                name: "ロシア語"
            },
            fr: {
                DeepLLangCode: "fr",
                id: "10",
                name: "フランス語"
            },
            fi: {
                DeepLLangCode: "fi",
                id: "11",
                name: "フィンランド語"
            },
            ka: {
                DeepLLangCode: "",
                id: "13",
                name: "グルジア語"
            },
            gu: {
                DeepLLangCode: "",
                id: "41",
                name: "グジャラート語"
            },
            ht: {
                DeepLLangCode: "",
                id: "71",
                name: "ハイチのクレオール語"
            },
            ko: {
                DeepLLangCode: "ko",
                id: "46",
                name: "韓国語"
            },
            nl: {
                DeepLLangCode: "nl",
                id: "8",
                name: "オランダ語"
            },
            ca: {
                DeepLLangCode: "",
                id: "4",
                name: "カタルーニャ語"
            },
            cs: {
                DeepLLangCode: "cs",
                id: "6",
                name: "チェコ語"
            },
            kn: {
                DeepLLangCode: "",
                id: "49",
                name: "カナダ語"
            },
            hr: {
                DeepLLangCode: "",
                id: "5",
                name: "クロアチア語"
            },
            lv: {
                DeepLLangCode: "lv",
                id: "20",
                name: "ラトビア語"
            },
            lo: {
                DeepLLangCode: "",
                id: "50",
                name: "ラオス語"
            },
            lt: {
                DeepLLangCode: "lt",
                id: "21",
                name: "リトアニア語"
            },
            ro: {
                DeepLLangCode: "ro",
                id: "27",
                name: "ルーマニア語"
            },
            mt: {
                DeepLLangCode: "",
                id: "23",
                name: "マルタ語"
            },
            mr: {
                DeepLLangCode: "",
                id: "53",
                name: "マラーティー語"
            },
            ml: {
                DeepLLangCode: "",
                id: "54",
                name: "マラヤーラム語"
            },
            ms: {
                DeepLLangCode: "",
                id: "51",
                name: "マレー語"
            },
            mk: {
                DeepLLangCode: "",
                id: "22",
                name: "マケドニア語"
            },
            bn: {
                DeepLLangCode: "",
                id: "38",
                name: "ベンガル語"
            },
            my: {
                DeepLLangCode: "",
                id: "39",
                name: "ビルマ語"
            },
            no: {
                DeepLLangCode: "",
                id: "24",
                name: "ノルウェー語"
            },
            pa: {
                DeepLLangCode: "",
                id: "57",
                name: "パンジャブ語"
            },
            pt: {
                DeepLLangCode: "pt",
                id: "25",
                name: "ポルトガル語"
            },
            ja: {
                DeepLLangCode: "ja",
                id: "45",
                name: "日本語"
            },
            sv: {
                DeepLLangCode: "sv",
                id: "28",
                name: "スウェーデン語"
            },
            sr: {
                DeepLLangCode: "",
                id: "30",
                name: "セルビア語"
            },
            si: {
                DeepLLangCode: "",
                id: "60",
                name: "シンハラ語"
            },
            sk: {
                DeepLLangCode: "sk",
                id: "31",
                name: "スロバキア語"
            },
            sl: {
                DeepLLangCode: "sl",
                id: "32",
                name: "スロベニア語"
            },
            sw: {
                DeepLLangCode: "",
                id: "74",
                name: "スワヒリ語"
            },
            te: {
                DeepLLangCode: "",
                id: "66",
                name: "テルグ語"
            },
            ta: {
                DeepLLangCode: "",
                id: "65",
                name: "タミル語"
            },
            th: {
                DeepLLangCode: "",
                id: "64",
                name: "タイ語"
            },
            tr: {
                DeepLLangCode: "tr",
                id: "33",
                name: "トルコ語"
            },
            uk: {
                DeepLLangCode: "uk",
                id: "34",
                name: "ウクライナ語"
            },
            es: {
                DeepLLangCode: "es",
                id: "73",
                name: "スペイン語"
            },
            he: {
                DeepLLangCode: "",
                id: "42",
                name: "ヘブライ語"
            },
            el: {
                DeepLLangCode: "el",
                id: "14",
                name: "ギリシャ語"
            },
            hu: {
                DeepLLangCode: "hu",
                id: "15",
                name: "ハンガリー語"
            },
            hy: {
                DeepLLangCode: "",
                id: "36",
                name: "アルメニア語"
            },
            it: {
                DeepLLangCode: "it",
                id: "16",
                name: "イタリア語"
            },
            hi: {
                DeepLLangCode: "",
                id: "43",
                name: "ヒンディー語"
            },
            id: {
                DeepLLangCode: "id",
                id: "44",
                name: "インドネシア語"
            },
            vi: {
                DeepLLangCode: "",
                id: "68",
                name: "ベトナム語"
            }
        },
        ko: {
            "zh-CN": {
                DeepLLangCode: "ZH-HANS",
                id: "59",
                name: "중국어(간체)"
            },
            "zh-TW": {
                DeepLLangCode: "ZH-HANT",
                id: "63",
                name: "중국어(번체)"
            },
            en: {
                DeepLLangCode: "en",
                id: "70",
                name: "영어"
            },
            sq: {
                DeepLLangCode: "",
                id: "1",
                name: "알바니아"
            },
            ar: {
                DeepLLangCode: "ar",
                id: "35",
                name: "아라비아 말"
            },
            az: {
                DeepLLangCode: "",
                id: "37",
                name: "아제르바이잔"
            },
            ga: {
                DeepLLangCode: "",
                id: "18",
                name: "아일랜드"
            },
            et: {
                DeepLLangCode: "et",
                id: "9",
                name: "에스토니아 사람"
            },
            bg: {
                DeepLLangCode: "bg",
                id: "3",
                name: "불가리아 사람"
            },
            is: {
                DeepLLangCode: "",
                id: "17",
                name: "아이슬란드어"
            },
            pl: {
                DeepLLangCode: "pl",
                id: "26",
                name: "광택"
            },
            fa: {
                DeepLLangCode: "",
                id: "56",
                name: "페르시아 인"
            },
            da: {
                DeepLLangCode: "da",
                id: "7",
                name: "덴마크 말"
            },
            de: {
                DeepLLangCode: "de",
                id: "12",
                name: "독일 사람"
            },
            ru: {
                DeepLLangCode: "ru",
                id: "58",
                name: "러시아인"
            },
            fr: {
                DeepLLangCode: "fr",
                id: "10",
                name: "프랑스 국민"
            },
            fi: {
                DeepLLangCode: "fi",
                id: "11",
                name: "핀란드어"
            },
            ka: {
                DeepLLangCode: "",
                id: "13",
                name: "그루지야 사람"
            },
            gu: {
                DeepLLangCode: "",
                id: "41",
                name: "구자라트어"
            },
            ht: {
                DeepLLangCode: "",
                id: "71",
                name: "아이티 크리올어"
            },
            ko: {
                DeepLLangCode: "ko",
                id: "46",
                name: "한국인"
            },
            nl: {
                DeepLLangCode: "nl",
                id: "8",
                name: "네덜란드 사람"
            },
            ca: {
                DeepLLangCode: "",
                id: "4",
                name: "카탈로니아 사람"
            },
            cs: {
                DeepLLangCode: "cs",
                id: "6",
                name: "체코 사람"
            },
            kn: {
                DeepLLangCode: "",
                id: "49",
                name: "칸나다어"
            },
            hr: {
                DeepLLangCode: "",
                id: "5",
                name: "크로아티아어"
            },
            lv: {
                DeepLLangCode: "lv",
                id: "20",
                name: "라트비아 사람"
            },
            lo: {
                DeepLLangCode: "",
                id: "50",
                name: "라오스"
            },
            lt: {
                DeepLLangCode: "lt",
                id: "21",
                name: "리투아니아 사람"
            },
            ro: {
                DeepLLangCode: "ro",
                id: "27",
                name: "루마니아 사람"
            },
            mt: {
                DeepLLangCode: "",
                id: "23",
                name: "몰티즈"
            },
            mr: {
                DeepLLangCode: "",
                id: "53",
                name: "마라티어"
            },
            ml: {
                DeepLLangCode: "",
                id: "54",
                name: "말라얄람어"
            },
            ms: {
                DeepLLangCode: "",
                id: "51",
                name: "말레이 사람"
            },
            mk: {
                DeepLLangCode: "",
                id: "22",
                name: "마케도니아 어"
            },
            bn: {
                DeepLLangCode: "",
                id: "38",
                name: "벵골 사람"
            },
            my: {
                DeepLLangCode: "",
                id: "39",
                name: "버마 사람"
            },
            no: {
                DeepLLangCode: "",
                id: "24",
                name: "노르웨이 인"
            },
            pa: {
                DeepLLangCode: "",
                id: "57",
                name: "펀자브어"
            },
            pt: {
                DeepLLangCode: "pt",
                id: "25",
                name: "포르투갈 인"
            },
            ja: {
                DeepLLangCode: "ja",
                id: "45",
                name: "일본어"
            },
            sv: {
                DeepLLangCode: "sv",
                id: "28",
                name: "스웨덴어"
            },
            sr: {
                DeepLLangCode: "",
                id: "30",
                name: "세르비아 사람"
            },
            si: {
                DeepLLangCode: "",
                id: "60",
                name: "신할라어"
            },
            sk: {
                DeepLLangCode: "sk",
                id: "31",
                name: "슬로바키아 사람"
            },
            sl: {
                DeepLLangCode: "sl",
                id: "32",
                name: "슬로베니아"
            },
            sw: {
                DeepLLangCode: "",
                id: "74",
                name: "스와힐리어"
            },
            te: {
                DeepLLangCode: "",
                id: "66",
                name: "텔루구어"
            },
            ta: {
                DeepLLangCode: "",
                id: "65",
                name: "타밀 사람"
            },
            th: {
                DeepLLangCode: "",
                id: "64",
                name: "태국어"
            },
            tr: {
                DeepLLangCode: "tr",
                id: "33",
                name: "터키 사람"
            },
            uk: {
                DeepLLangCode: "uk",
                id: "34",
                name: "우크라이나 말"
            },
            es: {
                DeepLLangCode: "es",
                id: "73",
                name: "스페인 사람"
            },
            he: {
                DeepLLangCode: "",
                id: "42",
                name: "헤브라이 사람"
            },
            el: {
                DeepLLangCode: "el",
                id: "14",
                name: "그리스 사람"
            },
            hu: {
                DeepLLangCode: "hu",
                id: "15",
                name: "헝가리 인"
            },
            hy: {
                DeepLLangCode: "",
                id: "36",
                name: "아르메니아 사람"
            },
            it: {
                DeepLLangCode: "it",
                id: "16",
                name: "이탈리아 사람"
            },
            hi: {
                DeepLLangCode: "",
                id: "43",
                name: "힌디 어"
            },
            id: {
                DeepLLangCode: "id",
                id: "44",
                name: "인도네시아 인"
            },
            vi: {
                DeepLLangCode: "",
                id: "68",
                name: "베트남 사람"
            }
        },
        ms: {
            "zh-CN": {
                DeepLLangCode: "ZH-HANS",
                id: "59",
                name: "Cina (Mudah)"
            },
            "zh-TW": {
                DeepLLangCode: "ZH-HANT",
                id: "63",
                name: "Cina (Tradisional)"
            },
            en: {
                DeepLLangCode: "en",
                id: "70",
                name: "Inggeris"
            },
            sq: {
                DeepLLangCode: "",
                id: "1",
                name: "bahasa Albania"
            },
            ar: {
                DeepLLangCode: "ar",
                id: "35",
                name: "bahasa arab"
            },
            az: {
                DeepLLangCode: "",
                id: "37",
                name: "Azerbaijan"
            },
            ga: {
                DeepLLangCode: "",
                id: "18",
                name: "irish"
            },
            et: {
                DeepLLangCode: "et",
                id: "9",
                name: "bahasa estonia"
            },
            bg: {
                DeepLLangCode: "bg",
                id: "3",
                name: "bahasa Bulgaria"
            },
            is: {
                DeepLLangCode: "",
                id: "17",
                name: "bahasa Iceland"
            },
            pl: {
                DeepLLangCode: "pl",
                id: "26",
                name: "Poland"
            },
            fa: {
                DeepLLangCode: "",
                id: "56",
                name: "Parsi"
            },
            da: {
                DeepLLangCode: "da",
                id: "7",
                name: "danish"
            },
            de: {
                DeepLLangCode: "de",
                id: "12",
                name: "Jerman"
            },
            ru: {
                DeepLLangCode: "ru",
                id: "58",
                name: "bahasa Rusia"
            },
            fr: {
                DeepLLangCode: "fr",
                id: "10",
                name: "Perancis"
            },
            fi: {
                DeepLLangCode: "fi",
                id: "11",
                name: "bahasa Finland"
            },
            ka: {
                DeepLLangCode: "",
                id: "13",
                name: "Georgian"
            },
            gu: {
                DeepLLangCode: "",
                id: "41",
                name: "bahasa gujarati"
            },
            ht: {
                DeepLLangCode: "",
                id: "71",
                name: "Kreol Haiti"
            },
            ko: {
                DeepLLangCode: "ko",
                id: "46",
                name: "Korea"
            },
            nl: {
                DeepLLangCode: "nl",
                id: "8",
                name: "Belanda"
            },
            ca: {
                DeepLLangCode: "",
                id: "4",
                name: "Catalan"
            },
            cs: {
                DeepLLangCode: "cs",
                id: "6",
                name: "bahasa Czech"
            },
            kn: {
                DeepLLangCode: "",
                id: "49",
                name: "kannada"
            },
            hr: {
                DeepLLangCode: "",
                id: "5",
                name: "bahasa Croatia"
            },
            lv: {
                DeepLLangCode: "lv",
                id: "20",
                name: "bahasa Latvia"
            },
            lo: {
                DeepLLangCode: "",
                id: "50",
                name: "Lao"
            },
            lt: {
                DeepLLangCode: "lt",
                id: "21",
                name: "bahasa Lithuania"
            },
            ro: {
                DeepLLangCode: "ro",
                id: "27",
                name: "bahasa Romania"
            },
            mt: {
                DeepLLangCode: "",
                id: "23",
                name: "maltese"
            },
            mr: {
                DeepLLangCode: "",
                id: "53",
                name: "marathi"
            },
            ml: {
                DeepLLangCode: "",
                id: "54",
                name: "Malayalam"
            },
            ms: {
                DeepLLangCode: "",
                id: "51",
                name: "Melayu"
            },
            mk: {
                DeepLLangCode: "",
                id: "22",
                name: "Macedonia"
            },
            bn: {
                DeepLLangCode: "",
                id: "38",
                name: "Benggali"
            },
            my: {
                DeepLLangCode: "",
                id: "39",
                name: "Burma"
            },
            no: {
                DeepLLangCode: "",
                id: "24",
                name: "bahasa norwegia"
            },
            pa: {
                DeepLLangCode: "",
                id: "57",
                name: "punjabi"
            },
            pt: {
                DeepLLangCode: "pt",
                id: "25",
                name: "Portugis"
            },
            ja: {
                DeepLLangCode: "ja",
                id: "45",
                name: "Jepun"
            },
            sv: {
                DeepLLangCode: "sv",
                id: "28",
                name: "Bahasa Sweden"
            },
            sr: {
                DeepLLangCode: "",
                id: "30",
                name: "bahasa Serbia"
            },
            si: {
                DeepLLangCode: "",
                id: "60",
                name: "sinhala"
            },
            sk: {
                DeepLLangCode: "sk",
                id: "31",
                name: "bahasa Slovak"
            },
            sl: {
                DeepLLangCode: "sl",
                id: "32",
                name: "bahasa slovenia"
            },
            sw: {
                DeepLLangCode: "",
                id: "74",
                name: "bahasa Swahili"
            },
            te: {
                DeepLLangCode: "",
                id: "66",
                name: "telugu"
            },
            ta: {
                DeepLLangCode: "",
                id: "65",
                name: "tamil"
            },
            th: {
                DeepLLangCode: "",
                id: "64",
                name: "Thai"
            },
            tr: {
                DeepLLangCode: "tr",
                id: "33",
                name: "bahasa turki"
            },
            uk: {
                DeepLLangCode: "uk",
                id: "34",
                name: "Ukraine"
            },
            es: {
                DeepLLangCode: "es",
                id: "73",
                name: "bahasa Sepanyol"
            },
            he: {
                DeepLLangCode: "",
                id: "42",
                name: "bahasa ibrani"
            },
            el: {
                DeepLLangCode: "el",
                id: "14",
                name: "bahasa Yunani"
            },
            hu: {
                DeepLLangCode: "hu",
                id: "15",
                name: "Hungary"
            },
            hy: {
                DeepLLangCode: "",
                id: "36",
                name: "bahasa Armenia"
            },
            it: {
                DeepLLangCode: "it",
                id: "16",
                name: "Itali"
            },
            hi: {
                DeepLLangCode: "",
                id: "43",
                name: "Hindi"
            },
            id: {
                DeepLLangCode: "id",
                id: "44",
                name: "Indonesia"
            },
            vi: {
                DeepLLangCode: "",
                id: "68",
                name: "bahasa Vietnam"
            }
        },
        th: {
            "zh-CN": {
                DeepLLangCode: "ZH-HANS",
                id: "59",
                name: "จีน (ตัวย่อ)"
            },
            "zh-TW": {
                DeepLLangCode: "ZH-HANT",
                id: "63",
                name: "จีน (ดั้งเดิม)"
            },
            en: {
                DeepLLangCode: "en",
                id: "70",
                name: "ภาษาอังกฤษ"
            },
            sq: {
                DeepLLangCode: "",
                id: "1",
                name: "แอลเบเนีย"
            },
            ar: {
                DeepLLangCode: "ar",
                id: "35",
                name: "ภาษาอาหรับ"
            },
            az: {
                DeepLLangCode: "",
                id: "37",
                name: "อาเซอร์ไบจัน"
            },
            ga: {
                DeepLLangCode: "",
                id: "18",
                name: "ไอริช"
            },
            et: {
                DeepLLangCode: "et",
                id: "9",
                name: "เอสโตเนีย"
            },
            bg: {
                DeepLLangCode: "bg",
                id: "3",
                name: "บัลแกเรีย"
            },
            is: {
                DeepLLangCode: "",
                id: "17",
                name: "ไอซ์แลนด์"
            },
            pl: {
                DeepLLangCode: "pl",
                id: "26",
                name: "ขัด"
            },
            fa: {
                DeepLLangCode: "",
                id: "56",
                name: "เปอร์เซีย"
            },
            da: {
                DeepLLangCode: "da",
                id: "7",
                name: "ภาษาเดนมาร์ก"
            },
            de: {
                DeepLLangCode: "de",
                id: "12",
                name: "เยอรมัน"
            },
            ru: {
                DeepLLangCode: "ru",
                id: "58",
                name: "ภาษารัสเซีย"
            },
            fr: {
                DeepLLangCode: "fr",
                id: "10",
                name: "ภาษาฝรั่งเศส"
            },
            fi: {
                DeepLLangCode: "fi",
                id: "11",
                name: "ภาษาฟินแลนด์"
            },
            ka: {
                DeepLLangCode: "",
                id: "13",
                name: "จอร์เจีย"
            },
            gu: {
                DeepLLangCode: "",
                id: "41",
                name: "คุชราต"
            },
            ht: {
                DeepLLangCode: "",
                id: "71",
                name: "ชาวเฮติครีโอล"
            },
            ko: {
                DeepLLangCode: "ko",
                id: "46",
                name: "เกาหลี"
            },
            nl: {
                DeepLLangCode: "nl",
                id: "8",
                name: "ภาษาดัตช์"
            },
            ca: {
                DeepLLangCode: "",
                id: "4",
                name: "คาตาลัน"
            },
            cs: {
                DeepLLangCode: "cs",
                id: "6",
                name: "เช็ก"
            },
            kn: {
                DeepLLangCode: "",
                id: "49",
                name: "กันนาดา"
            },
            hr: {
                DeepLLangCode: "",
                id: "5",
                name: "โครเอเชีย"
            },
            lv: {
                DeepLLangCode: "lv",
                id: "20",
                name: "ลัตเวีย"
            },
            lo: {
                DeepLLangCode: "",
                id: "50",
                name: "ลาว"
            },
            lt: {
                DeepLLangCode: "lt",
                id: "21",
                name: "ลิทัวเนีย"
            },
            ro: {
                DeepLLangCode: "ro",
                id: "27",
                name: "โรมาเนีย"
            },
            mt: {
                DeepLLangCode: "",
                id: "23",
                name: "ภาษามอลตา"
            },
            mr: {
                DeepLLangCode: "",
                id: "53",
                name: "มราฐี"
            },
            ml: {
                DeepLLangCode: "",
                id: "54",
                name: "มาลายาลัม"
            },
            ms: {
                DeepLLangCode: "",
                id: "51",
                name: "มาเลย์"
            },
            mk: {
                DeepLLangCode: "",
                id: "22",
                name: "มาซิโดเนีย"
            },
            bn: {
                DeepLLangCode: "",
                id: "38",
                name: "เบงกาลี"
            },
            my: {
                DeepLLangCode: "",
                id: "39",
                name: "พม่า"
            },
            no: {
                DeepLLangCode: "",
                id: "24",
                name: "ชาวนอร์เวย์"
            },
            pa: {
                DeepLLangCode: "",
                id: "57",
                name: "ปัญจาบ"
            },
            pt: {
                DeepLLangCode: "pt",
                id: "25",
                name: "โปรตุเกส"
            },
            ja: {
                DeepLLangCode: "ja",
                id: "45",
                name: "ญี่ปุ่น"
            },
            sv: {
                DeepLLangCode: "sv",
                id: "28",
                name: "ภาษาสวีเดน"
            },
            sr: {
                DeepLLangCode: "",
                id: "30",
                name: "เซอร์เบีย"
            },
            si: {
                DeepLLangCode: "",
                id: "60",
                name: "สิงหล"
            },
            sk: {
                DeepLLangCode: "sk",
                id: "31",
                name: "สโลวัก"
            },
            sl: {
                DeepLLangCode: "sl",
                id: "32",
                name: "ภาษาสโลเวเนีย"
            },
            sw: {
                DeepLLangCode: "",
                id: "74",
                name: "สวาฮีลี"
            },
            te: {
                DeepLLangCode: "",
                id: "66",
                name: "เตลูกู"
            },
            ta: {
                DeepLLangCode: "",
                id: "65",
                name: "ทมิฬ"
            },
            th: {
                DeepLLangCode: "",
                id: "64",
                name: "แบบไทย"
            },
            tr: {
                DeepLLangCode: "tr",
                id: "33",
                name: "ตุรกี"
            },
            uk: {
                DeepLLangCode: "uk",
                id: "34",
                name: "ภาษายูเครน"
            },
            es: {
                DeepLLangCode: "es",
                id: "73",
                name: "สเปน"
            },
            he: {
                DeepLLangCode: "",
                id: "42",
                name: "ภาษาฮีบรู"
            },
            el: {
                DeepLLangCode: "el",
                id: "14",
                name: "กรีก"
            },
            hu: {
                DeepLLangCode: "hu",
                id: "15",
                name: "ฮังการี"
            },
            hy: {
                DeepLLangCode: "",
                id: "36",
                name: "อาร์เมเนีย"
            },
            it: {
                DeepLLangCode: "it",
                id: "16",
                name: "ภาษาอิตาลี"
            },
            hi: {
                DeepLLangCode: "",
                id: "43",
                name: "ฮินดี"
            },
            id: {
                DeepLLangCode: "id",
                id: "44",
                name: "ชาวอินโดนีเซีย"
            },
            vi: {
                DeepLLangCode: "",
                id: "68",
                name: "ภาษาเวียดนาม"
            }
        }
    },
    getLanguageList: function() {
        var e = chrome.i18n.getUILanguage() || "en";
        return this.allLanguageNames[e] || this.allLanguageNames[e.split("-")[0]] || this.allLanguageNames.en;
    },
    format: function(a) {
        var e = Object.keys(this.allLanguageNames["zh-CN"]);
        return e.includes(a) ? a : e.find(e => e.startsWith(a.split("-")[0]));
    }
};